/*Copyright 2007 Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    //CRC16 routine taken directly from Aleph One for exact
    //match when writing macbin headers
    package src.backend;

import src.gui.*;
import src.backend.*;

public class CRC16 {

    private int crc = 0;

    public CRC16() {
    }

    public void update(byte[] b) {
	for (int i=0; i<b.length; i++) {
	    int data = b[i] << 8;
	    for (int j=0; j<8; j++) {
		if (((data ^ this.crc) & 0x8000) != 0)
		    crc = (crc << 1) ^ 0x1021;
		else
		    crc <<= 1;
		data <<= 1;
	    }
	}
    }

    public void reset() {
	this.crc = 0;
    }

    public short getValue() {
	return (short) (0xFFFF & this.crc);
    }
}
