/*Copyright 2007 Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    package src.backend;

import src.gui.*;
import src.backend.*;

public class ChunkHeader {

    Chunk chunk;
    String tagString;
    int tag;
    int nextOffset;
    int offset;
    int length;
    private boolean hasChanged = false;
	
    public ChunkHeader() {
    }

    public void setChunk(Chunk chunk) {
	this.chunk = chunk;
	change();
    }

    public void setTag(int tag) {
	this.tag = tag;
	change();
    }

    public void setTagString(String tag) {
	this.tagString = tag;
    }

    public void setNextOffset(int nextOffset) {
	this.nextOffset = nextOffset;
	change();
    }

    public void setLength(int length) {
	this.length = length;
    }

    public void autoAdjust(int diff) {
	//	int diff = getLength() - len;
	System.out.println("Old length: "+getLength());
	adjust(diff);
	this.chunk.getLevel().getMapData().autoAdjust(diff, getOffset());
    }

    public void adjust(int len) {
	setLength(getLength() + len);
	System.out.println("New length: "+getLength());
    }

    public void setOffset(int offset) {
	this.offset = offset;
	change();
    }

    public Chunk getChunk() {
	return this.chunk;
    }

    public int getTag() {
	return this.tag;
    }

    public String getTagString() {
	return this.tagString;
    }

    public int getNextOffset() {
	return this.nextOffset;
    }

    public int getLength() {
	return this.length;
    }

    public int getOffset() {
	return this.offset;
    }

    public boolean hasChanged() {
	return this.hasChanged;
    }

    public void change() {
	this.hasChanged = true;
	if (this.chunk != null)
	    this.chunk.change();
    }

    public void resetChange() {
	this.hasChanged = false;
    }

    public void write() {
	MapWriter mw = this.chunk.getLevel().getMapData().getMapWriter();
	mw.seek(this.offset);
	mw.writeInt(this.tag);
	mw.writeInt(this.nextOffset);
	mw.writeInt(this.length);
	mw.writeInt(0);
    }
}
