/*Copyright 2007 Darren Watts

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.backend;

import java.io.*;
import src.backend.*;
import java.util.ArrayList;

public class GetFile
{
    private BufferedReader Ext_File;
    private BufferedWriter Ext_FileW;
    String fileName;

    public GetFile(String ext_file){
        fileName = ext_file;
       try {
           try{
               Ext_File = new BufferedReader(
                       new InputStreamReader(new FileInputStream(ext_file))
               );
           }catch(FileNotFoundException ex){
               Ext_FileW = new BufferedWriter(
                       new OutputStreamWriter(new FileOutputStream(ext_file))
               );
           }
       }
       catch( Exception e ) {System.out.println(e);}
    }

    public String getLine(){
       try {
    	   return Ext_File.readLine();
       } catch( Exception e ) {  return ""; }
    }

    public String getNumChars(int num){
        String comment = "";
        try{
            for(int i = 0; i < num; i++){
                int next = Ext_File.read();
                if(next != -1){
                    comment += (char) next;
                }
                else break;
            }
        } catch(Exception e){
            return null;
        }
        return comment;
    }

    public ArrayList getAllLinesOfFile(){
        String nextLine = "";
        ArrayList linesOfFile = new ArrayList();
        try{
            nextLine = getLine();
            while(nextLine != null){
                linesOfFile.add(nextLine);
                nextLine = getLine();
            }
        } catch(Exception e){
            System.out.println(e);
            return linesOfFile;
        }
        return linesOfFile;
    }

    public void setLine(String line){
        try{
            Ext_FileW = new BufferedWriter(
                    new OutputStreamWriter(new FileOutputStream(fileName))
                        );
            Ext_FileW.write(line);
        }catch(Exception e){}
    }

    public void clearFile(){
        try{
            Ext_FileW = new BufferedWriter(
                    new OutputStreamWriter(new FileOutputStream(fileName))
                        );
            Ext_FileW.write("");
        } catch(Exception e) {}
    }

    public boolean havehitEOF(){
       try {
    	   return !Ext_File.ready();
       } catch( Exception e ) {  return true; }
    }

    public void close(){
       try {
    	   Ext_File.close();
           if(Ext_FileW != null)
               Ext_FileW.close();
       } catch( Exception e ) { }
    }

}
