/*Copyright 2007 Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    //The new JUCE chunk is a one-line comment limited to 64 characters
    //that is printed by Aleph One at the beginning of a game.

    package src.backend;

import src.gui.*;
import src.backend.*;

    public class JuceEntry extends Entry {

	public static final int ENTRY_LENGTH = 512;
	private byte[] comment = new byte[this.ENTRY_LENGTH];

	public JuceEntry(Chunk chunk) {
	    super(chunk);
	}

	public JuceEntry(Chunk chunk, byte[] comment) {
	    super(chunk);
	    this.comment = comment;
	}

	public String getComment() {
	    String str = "";
	    for (int i=0; i<this.comment.length; i++) {
		if (this.comment[i] != 0)
		    str += (char) this.comment[i];
	    }
	    return str;
	}

	public void setComment(String str) {
	    for (int i=0; i<str.length(); i++) {
		this.comment[i] = (byte) str.charAt(i);
	    }
	    for (int i=str.length(); i<this.ENTRY_LENGTH; i++) {
		this.comment[i] = 0;
	    }
	}

	public void write() {
	    super.write();
	    MapWriter mw = this.chunk.getLevel().getMapData().getMapWriter();
	    for (int i=0; i<this.comment.length; i++) {
		mw.writeByte(comment[i]);
	    }
	}
    }
