/*
  Copyright 2007 Darren Watts

  This file is part of JUICE.

  JUICE is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  JUICE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with JUICE; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.backend;

import java.util.StringTokenizer;

public class Preferences {
    public static String MAPS_PATH = "";
    public static String SCRIPTS_PATH = "";
    public static double MIN_MULT = 1;
    public static double MAX_MULT = 2;
    public static int APPEAR_PERCENT = 100;

    public static void loadPrefs(){
        GetFile file = new GetFile("JUICE Preferences");
        StringTokenizer st;
        String currentToken = "";
        while(!file.havehitEOF()){
            st = new StringTokenizer(file.getLine(), "=");
            try{
                currentToken = st.nextToken();
            } catch(Exception e){continue;}
            try{
                if (currentToken.equals("MAPS_PATH")){
                    MAPS_PATH = st.nextToken();
                    continue;
                }
            } catch(Exception e){
                MAPS_PATH = "";
                continue;
            }
            try{
                if (currentToken.equals("SCRIPTS_PATH")){
                    SCRIPTS_PATH = st.nextToken();
                    continue;
                }
            } catch(Exception e){
                SCRIPTS_PATH = "";
                continue;
            }
            try{
                if (currentToken.equals("MIN")){
                    MIN_MULT = Double.parseDouble(st.nextToken());
                    continue;
                }
            } catch(Exception e){
                MAX_MULT = 1;
                continue;
            }
            try{
                if (currentToken.equals("MAX")){
                    MAX_MULT = Double.parseDouble(st.nextToken());
                    continue;
                }
            } catch(Exception e){
                MAX_MULT = 2;
                continue;
            }
            try{
                if (currentToken.equals("APPEAR_PERCENT")){
                    APPEAR_PERCENT = Integer.parseInt(st.nextToken());
                    continue;
                }
            } catch(Exception e){
                APPEAR_PERCENT = 100;
            }
        }
        String path = file.getLine();
        file.close();
    }

    public static void setPrefs(String mapsPath, String scriptsPath, double min, double max, int percent){
        MAPS_PATH = mapsPath;
        SCRIPTS_PATH = scriptsPath;
        MIN_MULT = min;
        MAX_MULT = max;
        APPEAR_PERCENT = percent;
        writePrefs();
    }

    private static void writePrefs(){
        GetFile file = new GetFile("JUICE Preferences");
        file.clearFile();
        file.setLine("MAPS_PATH=" + MAPS_PATH + "\n" +
                     "SCRIPTS_PATH=" + SCRIPTS_PATH + "\n" +
                     "MIN=" + MIN_MULT + "\n" +
                     "MAX=" + MAX_MULT + "\n" +
                     "APPEAR_PERCENT=" + APPEAR_PERCENT);
        file.close();
    }
}
