/*Copyright 2007 Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


    package src.backend;

import src.gui.*;
import src.backend.*;

public class ShapeDescriptor {

    private int desc;
    private short bitmap;
    private short collection;
    private short clut;

    public ShapeDescriptor(int d) {
	this.desc = d;
	interpretDesc();
    }

    public ShapeDescriptor(short s) {
	this.desc = (int) s;
	interpretDesc();
    }

    public int getDesc() {return this.desc;}
    public short getBmp() {return this.bitmap;}
    public short getColl() {return this.collection;}
    public short getClut() {return this.clut;}

    public void setDesc(int d) {this.desc = d; interpretDesc();}
    public void setBmp(short b) {this.bitmap = b; updateDesc();}
    public void setColl(short c) {this.collection = c; updateDesc();}
    public void setClut(short c) {this.clut = c; updateDesc();}
    //int versions for Darren "Lazy" Watts
    public void setBmp(int b) {this.bitmap = (short) b; updateDesc();}
    public void setColl(int c) {this.collection = (short) c; updateDesc();}
    public void setClut(int c) {this.clut = (short) c; updateDesc();}

    public void interpretDesc() {
	this.bitmap = (short) (this.desc & 0x00ff);
	this.collection = (short) ((this.desc >> 8) & (0x001f));
	this.clut = (short) ((this.desc >> 13) & (0x0003));
    }

    public void updateDesc() {
	this.desc = (this.clut << 13) | (this.collection << 8) | this.bitmap;
    }
}
