/*Copyright 2007 Darren Watts and Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    package src.backend;

import javax.swing.JFrame;
import java.awt.Toolkit;
import java.awt.Dimension;

public class StaticFunctions {

    private final static String version = "1.1.1";
    public static final short MAX_JUCE_COMMENT_SIZE = 512;

    public static final String[] PANEL_TYPES = {
	"00. Water: Oxygen Refuel",
	"01. Water: Energy Refuel (1x)",
	"02. Water: Energy Refuel (2x)",
	"03. Water: Tag Switch (Accepts Chip)",
	"04. Water: Light Switch",
	"05. Water: Platform Switch",
	"06. Water: Tag Switch",
	"07. Water: Pattern Buffer",
	"08. Water: Computer Terminal",
	"09. Water: Tag Switch (Destroyable)",
	"10. Lava: Energy Refuel (1x)",
	"11. Lava: Energy Refuel (2x)",
	"12. Lava: Energy Refuel (3x)",
	"13. Lava: Light Switch",
	"14. Lava: Platform Switch",
	"15. Lava: Tag Switch",
	"16. Lava: Pattern Buffer",
	"17. Lava: Computer Terminal",
	"18. Lava: Oxygen Refuel",
	"19. Lava: Tag Switch (Accepts Chip)",
	"20. Lava: Tag Switch (Destroyable)",
	"21. Sewage: Energy Refuel (1x)",
	"22. Sewage: Energy Refuel (2x)",
	"23. Sewage: Energy Refuel (3x)",
	"24. Sewage: Light Switch",
	"25. Sewage: Platform Switch",
	"26. Sewage: Tag Switch",
	"27. Sewage: Pattern Buffer",
	"28. Sewage: Computer Terminal",
	"29. Sewage: Oxygen Refuel",
	"30. Sewage: Tag Switch (Accepts Chip)",
	"31. Sewage: Tag Switch (Destroyable)",
	"32. Pfhor: Energy Refuel (1x)",
	"33. Pfhor: Energy Refuel (2x)",
	"34. Pfhor: Energy Refuel (3x)",
	"35. Pfhor: Light Switch",
	"36. Pfhor: Platform Switch",
	"37. Pfhor: Tag Switch",
	"38. Pfhor: Pattern Buffer",
	"39. Pfhor: Computer Terminal",
	"40. Pfhor: Oxygen Refuel",
	"41. Pfhor: Tag Switch (Accepts Chip)",
	"42. Pfhor: Tag Switch (Destroyable)",
	"43. Jjaro: Energy Refuel (1x)",
	"44. Jjaro: Energy Refuel (2x)",
	"45. Jjaro: Energy Refuel (3x)",
	"46. Jjaro: Light Switch",
	"47. Jjaro: Platform Switch",
	"48. Jjaro: Tag Switch",
	"49. Jjaro: Pattern Buffer",
	"50. Jjaro: Computer Terminal",
	"51. Jjaro: Oxygen Refuel",
	"52. Jjaro: Tag Switch (Accepts Chip)",
	"53. Jjaro: Tag Switch (Destroyable)"
    };

    public static final String[] TRANSFER_MODES = {
       	"Normal",
	"Fade to Black",
	"Invisibility",
	"Subtle Invisibility",
	"Pulsate",
	"Wobble",
	"Fast Wobble",
	"Static (100%)",
	"Static (50%)",
	"Landscape",
	"Smear",
	"Fade Out Static",
	"Pulsating Static",
	"Fold In",
	"Fold Out",
	"Horizontal Slide",
	"Fast Horizontal Slide",
	"Vertical Slide",
	"Fast Vertical Slide",
	"Wander",
	"Fast Wander",
	"Big Landscape"
    };

    public static final short[] TEXTURE_CUTOFFS = {30, 60, 90};

    public static final byte WATER_COLLECTION = 17;

    public static final String[] SIDS_TYPES = {
	"Full Side",
	"High Side",
	"Low Side",
	"Composite Side",
	"Split Side"
    };

    private final static String[] placEntryNames = {
	"Knife",
	"Magnum",
	"Magnum Clip",
	"Fusion Pistol",
	"Fusion Battery",
	"Assault Rifle",
	"Assault Rifle Clip",
	"Grenades",
	"Missile Launcher",
	"Missile 2-pack",
	"Invisibility Powerup",
	"Invincibility Powerup",
	"Infravision Powerup",
	"Alien Weapon",
	"Alien Weapon Ammunition",
	"Napalm Launcher",
	"Napalm Canister",
	"Extravision Powerup",
	"Oxygen Powerup",
	"Energy Powerup x1",
	"Energy Powerup x2",
	"Energy Powerup x3",
	"Shotgun",
	"Shotgun Catridge",
	"S'pht Door Key",
	"Uplink Chip",
	"Slate Ball",
	"Red Ball (the skull)",
	"Violet Ball",
	"Yellow Ball",
	"White Ball",
	"Orange Ball",
	"Blue Ball",
	"Green Ball",
	"Sub-Machine Gun",
	"SMG Ammo",
	"Player",
	"Tick (energy)",
	"Tick (oxygen)",
	"Tick (kamikaze)",
	"S'pht (minor)",
	"S'pht (major)",
	"S'pht (minor invisible)",
	"S'pht (major invisible)",
	"Pfhor Fighter (minor)",
	"Pfhor Fighter (major)",
	"Pfhor Fighter (minor projectile)",
	"Pfhor Fighter (major projectile)",
	"Bob (crew)",
	"Bob (science)",
	"Bob (security)",
	"Bob (assimilated)",
	"Drone (minor)",
	"Drone (major)",
	"Drone (big minor)",
	"Drone (big major)",
	"Drone (Durandal)",
	"Cyborg (minor)",
	"Cyborg (major)",
	"Cyborg (minor flame)",
	"Cyborg (major flame)",
	"Enforcer (minor)",
	"Enforcer (major)",
	"Hunter (minor)",
	"Hunter (major)",
	"Trooper (minor)",
	"Trooper (major)",
	"Mother of All Cyborgs",
	"Mother of All Hunters",
	"F'lickta (sewage)",
	"F'lickta (water)",
	"F'lickta (lava)",
	"S'pht'kr (minor)",
	"S'pht'kr (major)",
	"Juggernaut (minor)",
	"Juggernaut (major)",
	"Tiny Fighter",
	"Tiny Bob",
	"Tiny F'lickta",
	"VacBob (crew)",
	"VacBob (science)",
	"VacBob (security)",
	"VacBob (assimilated)"
    };

    public static final String[] monsters = {
	"Tick (energy)",
	"Tick (oxygen)",
	"Tick (kamikaze)",
	"S'pht (minor)",
	"S'pht (major)",
	"S'pht (minor invisible)",
	"S'pht (major invisible)",
	"Pfhor Fighter (minor)",
	"Pfhor Fighter (major)",
	"Pfhor Fighter (minor projectile)",
	"Pfhor Fighter (major projectile)",
	"Bob (crew)",
	"Bob (science)",
	"Bob (security)",
	"Bob (assimilated)",
	"Drone (minor)",
	"Drone (major)",
	"Drone (big minor)",
	"Drone (big major)",
	"Drone (Durandal)",
	"Cyborg (minor)",
	"Cyborg (major)",
	"Cyborg (minor flame)",
	"Cyborg (major flame)",
	"Enforcer (minor)",
	"Enforcer (major)",
	"Hunter (minor)",
	"Hunter (major)",
	"Trooper (minor)",
	"Trooper (major)",
	"Mother of All Cyborgs",
	"Mother of All Hunters",
	"F'lickta (sewage)",
	"F'lickta (water)",
	"F'lickta (lava)",
	"S'pht'kr (minor)",
	"S'pht'kr (major)",
	"Juggernaut (minor)",
	"Juggernaut (major)",
	"Tiny Fighter",
	"Tiny Bob",
	"Tiny F'lickta",
	"VacBob (crew)",
	"VacBob (science)",
	"VacBob (security)",
	"VacBob (assimilated)"
    };

    //public static final int[] SCENERY_INDEXES = {13, 0, 28, 50 ,39, 61};
    public static final int LAVA_START = 0;
    public static final int LAVA_END = 12;
    public static final int WATER_START = 13;
    public static final int WATER_END = 27;
    public static final int SEWAGE_START = 28;
    public static final int SEWAGE_END = 38;
    public static final int PFHOR_START = 39;
    public static final int PFHOR_END = 49;
    public static final int JJARO_START = 50;
    public static final int JJARO_END = 60;

    public static final String[] scenery = {
	//lava scenery
	"Light Dirt",
	"Dark Dirt",
	"Bones",
	"Bone",
	"Ribs",
	"Skull",
	"Hanging Light #1",
	"Hanging Light #2",
	"Large Cylinder",
	"Small Cylinder",
	"Block #1",
	"Block #2",
	"Block #3",
	//water scenery
	"Pistol Clip",
	"Short Light",
	"Long Light",
	"Siren",
	"Rocks",
	"Blood Puddles",
	"Water Filtration Device",
	"Bloody Gun",
	"Bloody Stuff",
	"Puddles",
	"Big Puddles",
	"Security Monitor",
	"Alien Trash Can",
	"Machine",
	"Fighter's Staff",
   	//scenery for set 3 (sewage)
	"Stubby Greeb Light",
	"Long Green Light",
	"Junk",
	"Big Antenna",
	"Small Antenna",
	"Alien Trashcan",
	"Bones",
	"Big Bones",
	"Pfhor Pieces",
	"Bob Pieces",
	"Bob Blood",
	//scenery for set 5 (pfhor)
	"Green Light",
	"Small Alien Light",
	"Alien Ceiling Light",
	"Bulbous Yellow Object",
	"Square Grey Organic Object",
	"Pfhor Skeleton",
	"Pfhor Mask",
	"Green Stuff",
	"Hunter Shield",
	"Bones",
	"Alien Sludge",
	//jjaro
	"Short Ceiling Light",
	"Tall Light",
	"Weird Rod",
	"Pfhor Ship",
	"Sun",
	"Large Glass Container",
	"Nub 1",
	"Nub 2",
	"Lh'owon",
	"Floor Whip Antenna",
	"Ceiling Whip Antenna"
    };

    public static final String[] items = {
	"Knife",
	"Magnum",
	"Magnum Clip",
	"Fusion Pistol",
	"Fusion Battery",
	"Assault Rifle",
	"Assault Rifle Clip",
	"Grenades",
	"Missile Launcher",
	"Missile 2-pack",
	"Invisibility Powerup",
	"Invincibility Powerup",
	"Infravision Powerup",
	"Alien Weapon",
	"Alien Weapon Ammunition",
	"Napalm Launcher",
	"Napalm Canister",
	"Extravision Powerup",
	"Oxygen Powerup",
	"Energy Powerup x1",
	"Energy Powerup x2",
	"Energy Powerup x3",
	"Shotgun",
	"Shotgun Catridge",
	"S'pht Door Key",
	"Uplink Chip",
	"Slate Ball",
	"Red Ball (the skull)",
	"Violet Ball",
	"Yellow Ball",
	"White Ball",
	"Orange Ball",
	"Blue Ball",
	"Green Ball",
	"Sub-Machine Gun",
	"SMG Ammo"
    };

    //player team colors
    public static final String[] player = {
	"Slate Team",
	"Red Team",
	"Violet Team",
	"Yellow Team",
	"White Team",
	"Orange Team",
	"Blue Team",
	"Green Team"
    };

    public static final String[] goals = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "10"};

    public static final String[] sounds = {
	"Water",
	"Sewage",
	"Lava",
	"Goo",
	"Under Media",
	"Wind",
	"Waterfall",
	"Siren",
	"Fan",
	"S'pht Door",
	"S'pht Platform",
	"Heavy S'pht Door",
	"Heavy S'pht Platform",
	"Light Machinery",
	"Heavy Machinery",
	"Tranformer",
	"Sparking Transformer",
	"Machine Binder",
	"Machine Bookpress",
	"Machine Puncher",
	"Electric Hum",
	"Siren",
	"Night Wind",
	"Pfhor Door",
	"Pfhor Platform",
	"Pfhor Ship #1",
	"Pfhor Ship #2",
	"Jjaro Ship"
    };

    //objs subtype names
    public static final String[][] OBJS_SUBTYPES = {monsters, scenery, items, player, goals, sounds};

    //objs type names
    public static final String[] OBJS_TYPES = {"Monster", "Scenery", "Item", "Player", "Goal", "Sound"};

    public static final String[] polygonTypeNames = {
	"Normal",
	"Item Impassable",
	"Monster Impassable",
	"Hill",
	"Base",
	"Platform",
	"Light On Trigger",
	"Platform On Trigger",
	"Light Off Trigger",
	"Platform Off Trigger",
	"Teleporter",
	"Zone Border",
	"Goal",
	"Visible Monster Trigger",
	"Invisible Monster Trigger",
	"Dual Monster Trigger",
	"Item Trigger",
	"Must Be Explored",
	"Automatic Exit",
	"Minor Damage",
	"Major Damage",
	"Glue",
	"Glue Trigger",
	"Superglue"
    };

    public static final int NUMBER_OF_PLAC_TYPES = placEntryNames.length;

    public static final int LINS_CHUNK = 1279872595;
    public static final int PNTS_CHUNK = 0x504e5453;
    public static final int POLY_CHUNK = 1347374169;
    public static final int SIDS_CHUNK = 1397310547;
    public static final int LITE_CHUNK = 1279874117;
    public static final int OBJS_CHUNK = 1329744467;
    public static final int Minf_CHUNK = 1298755174;
    public static final int plac_CHUNK = 1886151011;
    public static final int medi_CHUNK = 1835361385;
    public static final int ambi_CHUNK = 1634558569;
    public static final int bonk_CHUNK = 1651469931;
    public static final int iidx_CHUNK = 1768514680;
    public static final int EPNT_CHUNK = 1162890836;
    public static final int PLAT_CHUNK = 1347174740;
    public static final int plat_CHUNK = 0x706c6174; //unmerged-map version of PLAT
    public static final int term_CHUNK = 1952805485;
    public static final int NOTE_CHUNK = 1313821765;
    public static final int WPpx_CHUNK = 1464889464;
    public static final int PXpx_CHUNK = 1347973240;
    public static final int PRpx_CHUNK = 1347580024;
    public static final int FXpx_CHUNK = 1180201080;
    public static final int MNpx_CHUNK = 1296986232;
    public static final int MAPS_CHUNK = 0x4D415053; //chunk found in Obed maps
    public static final int JUCE_CHUNK = 0x4a554345; //our own custom JUCE chunk! (for level comments)
    public static final int ShPa_CHUNK = 0x53685061;//embedded shapes patch

    //Save game (verboten) chunks
    public static final int[] SAVE_CHUNKS = //chunks that guarantee a save file
    {
	0x706c7972, //'plyr'
	0x64776f6c, //'dwol'
	0x6d6f626a, //'mobj'
	0x646f6f72, //'door'
	0x616c696e, //'alin'
	0x61706f6c, //'apol'
	0x6d4f6e73, //'mOns'
	0x66782020, //'fx  '
	0x62616e67, //'bang'
	0x77656170, //'weap'
	0x63696e74  //'cint'
    };

    public static void centerFrame(JFrame jf){
	Toolkit tk = Toolkit.getDefaultToolkit();
	Dimension screen = tk.getScreenSize();

	int lx = (int) ((screen.getWidth() * .5) - ( .5 * jf.getWidth() ));
	int ly = (int) ((screen.getHeight() * .5) - ( .5 * jf.getHeight() ));
	jf.setLocation(lx, ly);
    }

    public static String getPlacName(int i) {
	String name = "Object Unclassified";
	if (i < placEntryNames.length)
	    name = placEntryNames[i];
	return name;
    }

    public static String getVersion() {
	return version;
    }
}
