/*Copyright 2007 Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    package src.backend;

import src.gui.*;
import src.backend.*;
import java.io.*;

public class UnknownChunk extends Chunk{
    private byte[] data;

    public UnknownChunk(Level level, ChunkHeader header) {
	super(level, header);
	this.data = new byte[header.getLength()];
	MapWriter mw = this.level.getMapData().getMapWriter();
	mw.seek(this.header.getOffset() + 16);
	mw.read(this.data);
	//		for (int i=0; i<this.data.length; i++) {
	//			this.data[i] = mw.readByte();
	//		}
    }

    public void write() {
	super.write();
	MapWriter mw = this.level.getMapData().getMapWriter();
	mw.seek(this.header.getOffset() + 16);
	mw.write(this.data);
	//for (int i=0; i<this.data.length; i++) {
	//mw.writeByte(this.data[i]);
	//}
    }

    public int getNumEntries() {
	return 1;
    }

    public int getEntryLength() {
	return 1;
    }
}
