/*Copyright 2007 Darren Watts and Jonathan Irons

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

    //Watts gets the credit for this beauty, but I put it into
    //a more familiar programming style, etc, and added the
    //accessor + mutator --Irons

    //for converting an array of bytes into useful data
    package src.backend;

public class WrkArrayReader {

    private byte[] data;
    private int position;

    public WrkArrayReader(byte[] data) {
	this.data = data;
	this.position = 0;
    }

    public short readShort() {
	int b0 = this.data[this.position] & 0xff;
	this.position++;
	int b1 = this.data[this.position] & 0xff;
	this.position++;
	short s = (short) (b0 << 8 | b1);
	//	System.out.println(s);
	return s;
    }

    public void writeShort(short s) {
	this.data[this.position] = (byte) (s >> 8);
	this.position++;
	this.data[this.position] = (byte) (s);
	this.position++;
    }

    public int readInt() {
	int b0 = this.data[this.position] & 0xff;
	this.position++;
	int b1 = this.data[this.position] & 0xff;
	this.position++;
	int b2 = this.data[this.position] & 0xff;
	this.position++;
	int b3 = this.data[this.position] & 0xff;
	this.position++;
	int ans = (b0 << 24 | b1 << 16 | b2 << 8 | b3);
	return ans;
    }

    public void writeInt(int i) {
	this.data[this.position] = (byte) (i >> 24);
	this.position++;
	this.data[this.position] = (byte) (i >> 16);
	this.position++;
	this.data[this.position] = (byte) (i >> 8);
	this.position++;
	this.data[this.position] = (byte) (i);
	this.position++;
    }

    public int getPosition() {
	return this.position;
    }

    public void seek(int pos) {
	this.position = pos;
    }
}
