/*
Copyright 2007 Darren Watts

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.*;
import src.backend.*;
import src.gui.*;
import java.util.ArrayList;

public class FlagsFrame extends JFrame {

  private Model model;
  private ArrayList childFrames;

  public FlagsFrame() {
    model = new Model(this);
    childFrames = new ArrayList();
    try {
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    getContentPane().setLayout(null);
    this.setJMenuBar(jMenuBar1);
        mnuFile.setText("File");
        mnuOpen.setText("Open");
        mnuOpen.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem1_actionPerformed(e);
      }
    });
    chkSinglePlr.setText("Single Player");
        chkSinglePlr.setBounds(new Rectangle(16, 53, 139, 23));
        chkSinglePlr.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkSinglePlr_actionPerformed(e);
            }
        });
        chkCoop.setText("Co-operative");
        chkCoop.setBounds(new Rectangle(16, 74, 207, 23));
        chkCoop.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkCoop_actionPerformed(e);
            }
        });
        chkEMFH.setText("Every Man for Himself");
        chkEMFH.setBounds(new Rectangle(16, 95, 204, 23));
        chkEMFH.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkEMFH_actionPerformed(e);
            }
        });
        chkBall.setText("Kill the Man With the Ball");
        chkBall.setBounds(new Rectangle(16, 115, 210, 23));
        chkBall.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkBall_actionPerformed(e);
            }
        });
        chkKOTH.setText("King of the Hill");
        chkKOTH.setBounds(new Rectangle(16, 136, 220, 23));
        chkKOTH.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkKOTH_actionPerformed(e);
            }
        });
        chkCTF.setEnabled(false);
        chkCTF.setText("Capture the Flag");
        chkCTF.setBounds(new Rectangle(16, 157, 220, 23));
        chkDefense.setText("Defense");
        chkDefense.setBounds(new Rectangle(16, 199, 139, 23));
        chkDefense.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkDefense_actionPerformed(e);
            }
        });
        chkRugby.setText("Rugby");
        chkRugby.setBounds(new Rectangle(16, 178, 139, 23));
        chkRugby.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkRugby_actionPerformed(e);
            }
        });
        mnuExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
        mnuExit.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
        mnuExit.setText("Exit");
    levelSelector.setBounds(new Rectangle(16, 12, 186, 21));
    levelSelector.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        levelSelector_actionPerformed(e);
      }
    });
    jLabel1.setText("Path to map file:");
        jLabel1.setBounds(new Rectangle(40, 420, 218, 15));
        btnLoad.setBounds(new Rectangle(268, 353, 73, 21));
    btnLoad.setText("Load");
    btnLoad.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        btnLoad_actionPerformed(e);
      }
    });
        mnuEdit.setText("Edit");
        mnuPrefs.setText("Preferences");
        mnuPrefs.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem2_actionPerformed(e);
            }
        });
        mnuChngMapName.setText("Change Map Name");
        mnuChngMapName.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                mnuChngMapName_actionPerformed(e);
            }
        });
        jMenuItem1.setEnabled(false);
        jMenuItem1.setText("-------------------------");
        jMenuItem2.setText("Save");
        jMenuItem2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                jMenuItemSave_actionPerformed(e);
            }
        });
        jMenuItem3.setEnabled(false);
        jMenuItem3.setText("--------");
        chkExploration.setText("Exploration");
        chkExploration.setBounds(new Rectangle(240, 74, 139, 23));
        jLabel2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 14));
        jLabel2.setText("Environment Type:");
        jLabel2.setBounds(new Rectangle(240, 155, 225, 20));
        jLabel3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 14));
        jLabel3.setText("Gametypes:");
        jLabel3.setBounds(new Rectangle(16, 34, 213, 20));
        chkRetrieval.setText("Retrieval");
        chkRetrieval.setBounds(new Rectangle(240, 95, 139, 23));
        chkRetrieval.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkRetrieval_actionPerformed(e);
            }
        });
        chkRepair.setText("Repair");
        chkRepair.setBounds(new Rectangle(240, 115, 139, 23));
        chkRepair.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkRepair_actionPerformed(e);
            }
        });
        chkRescue.setText("Rescue");
        chkRescue.setBounds(new Rectangle(240, 136, 139, 23));
        chkRescue.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkRescue_actionPerformed(e);
            }
        });
        chkExtermination.setText("Extermination");
        chkExtermination.setBounds(new Rectangle(240, 53, 139, 23));
        chkExtermination.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkExtermination_actionPerformed(e);
            }
        });
        jLabel4.setFont(new java.awt.Font("Dialog", Font.PLAIN, 14));
        jLabel4.setText("Mission:");
        jLabel4.setBounds(new Rectangle(240, 34, 161, 20));
        chkLowGrav.setText("Low Gravity");
        chkLowGrav.setBounds(new Rectangle(240, 240, 204, 23));
        chkLowGrav.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkLowGrav_actionPerformed(e);
            }
        });
        chkRebellion.setText("Rebellion");
        chkRebellion.setBounds(new Rectangle(240, 219, 142, 23));
        chkRebellion.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkRebellion_actionPerformed(e);
            }
        });
        jCheckBox3.setText("Every Man for Himself");
        chkVacuum.setText("Vacuum");
        chkVacuum.setBounds(new Rectangle(240, 178, 208, 23));
        chkVacuum.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkVacuum_actionPerformed(e);
            }
        });
        chkMagnetic.setText("Magnetic");
        chkMagnetic.setBounds(new Rectangle(240, 199, 210, 23));
        chkMagnetic.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkMagnetic_actionPerformed(e);
            }
        });
        txtPath.setBounds(new Rectangle(16, 354, 234, 20));
        chkExploration.addActionListener(new FlagsFrame_chkExploration_actionAdapter(this));
        jLabel5.setFont(new java.awt.Font("Dialog", Font.PLAIN, 14));
        jLabel5.setText("Landscape:");
        jLabel5.setBounds(new Rectangle(121, 305, 182, 17));
        chkDayLhowon.setText("Daytime Lh\'owon");
        chkDayLhowon.setBounds(new Rectangle(121, 326, 179, 19));
        chkDayLhowon.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkDayLhowon_actionPerformed(e);
            }
        });
        chkNightLhowon.setText("Nighttime Lh\'owon");
        chkNightLhowon.setBounds(new Rectangle(121, 345, 178, 19));
        chkNightLhowon.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkNightLhowon_actionPerformed(e);
            }
        });
        chkMoon.setText("Moon");
        chkMoon.setBounds(new Rectangle(121, 363, 174, 19));
        chkMoon.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkMoon_actionPerformed(e);
            }
        });
        chkSpace.setToolTipText("");
        chkSpace.setActionCommand("chkSpace");
        chkSpace.setText("Space");
        chkSpace.setBounds(new Rectangle(121, 382, 181, 19));
        chkSpace.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                chkSpace_actionPerformed(e);
            }
        });
        jMenuItem4.setText("Item Parameters");
        jMenuItem4.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem4_actionPerformed(e);
            }
        });
        jMenuItem5.setText("Monster Parameters");
        jMenuItem5.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem5_actionPerformed(e);
            }
        });
        jMenuItem6.setText("Save As...");
        jMenuItem6.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem6_actionPerformed(e);
            }
        });
        jMenuItem7.setText("Level Comment");
        jMenuItem7.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem7_actionPerformed(e);
            }
        });
        progBar.setBounds(new Rectangle(16, 268, 340, 20));
        progBar.setIndeterminate(true);
        progBar.setVisible(false);
        jMenuItem8.setText("Polygons");
        jMenuItem8.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem8_actionPerformed(e);
            }
        });
        jMenuItem9.setText("Objects");
        jMenuItem9.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem9_actionPerformed(e);
            }
        });
        jMenuItem10.setText("Visual Mode");
        jMenuItem10.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem10_actionPerformed(e);
            }
        });
        jMenuItem11.setText("Lines");
        jMenuItem11.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem11_actionPerformed(e);
            }
        });
        jMenu1.setText("Commands");
        jMenuItem12.setText("Convert Textures...");
        jMenuItem12.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem12_actionPerformed(e);
            }
        });
        jMenu2.setText("Help");
        jMenuItem13.setText("About");
        jMenuItem13.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem13_actionPerformed(e);
            }
        });
        jMenuItem14.setText("Sides");
        jMenuItem14.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                jMenuItem14_actionPerformed(e);
            }
        });
        mnuAddShapesPatch.setText("Add Shapes Patch");
        mnuAddShapesPatch.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                mnuAddShapesPatch_actionPerformed(e);
            }
        });
        jMenuBar1.add(mnuFile);
        jMenuBar1.add(mnuEdit);
        jMenuBar1.add(jMenu1);
        jMenuBar1.add(jMenu2);
        mnuFile.add(mnuOpen);
        mnuFile.add(jMenuItem2);
        mnuFile.add(jMenuItem6);
        mnuFile.add(jMenuItem3);
        mnuFile.add(mnuExit);
        this.getContentPane().add(btnLoad);
        this.getContentPane().add(txtPath);
        this.getContentPane().add(levelSelector);
        this.getContentPane().add(progBar);

        /*Landscape stuff
        this.getContentPane().add(jLabel5);
        this.getContentPane().add(chkDayLhowon);
        this.getContentPane().add(chkNightLhowon);
        this.getContentPane().add(chkMoon);
        this.getContentPane().add(chkSpace);*/

        this.getContentPane().add(jLabel3);
        this.getContentPane().add(chkSinglePlr);
        this.getContentPane().add(chkCoop);
        this.getContentPane().add(chkEMFH);
        this.getContentPane().add(jCheckBox3);
        this.getContentPane().add(jLabel2);
        this.getContentPane().add(jLabel4);
        this.getContentPane().add(jLabel1);
        this.getContentPane().add(chkBall);
        this.getContentPane().add(chkKOTH);
        this.getContentPane().add(chkRugby);
        this.getContentPane().add(chkVacuum);
        this.getContentPane().add(chkMagnetic);
        this.getContentPane().add(chkRebellion);
        this.getContentPane().add(chkLowGrav);
        this.getContentPane().add(chkExtermination);
        this.getContentPane().add(chkExploration);
        this.getContentPane().add(chkRetrieval);
        this.getContentPane().add(chkRepair);
        this.getContentPane().add(chkRescue);
        this.getContentPane().add(chkDefense);
        this.getContentPane().add(chkCTF);
        mnuEdit.add(jMenuItem4); // Item plac
        mnuEdit.add(jMenuItem5); // Monster plac
        mnuEdit.add(jMenuItem8); // Polygons
        mnuEdit.add(jMenuItem9); // Objects
        mnuEdit.add(jMenuItem11);
        mnuEdit.add(jMenuItem14);
        mnuEdit.add(mnuAddShapesPatch);
        mnuEdit.add(jMenuItem7);
        mnuEdit.add(mnuChngMapName); // Map name change
        mnuEdit.add(jMenuItem10); // Visual Mode
        mnuEdit.add(jMenuItem1); // Seperator
        mnuEdit.add(mnuPrefs); // Preferences
        jMenu1.add(jMenuItem12);
        jMenu2.add(jMenuItem13);
        /*chkDayLhowon.setEnabled(false);
        chkNightLhowon.setEnabled(false);
        chkMoon.setEnabled(false);
        chkSpace.setEnabled(false);*/

        jLabel1.setVisible(false);
        txtPath.setVisible(false);
        btnLoad.setVisible(false);

        setSize(400, 350);
        setTitle("JUICE");
        setResizable(false);
        StaticFunctions.centerFrame(this);
        setVisible(true);

    } // End init

  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu mnuFile = new JMenu();
  JMenuItem mnuOpen = new JMenuItem();
  JMenuItem mnuExit = new JMenuItem();
  JCheckBox chkSinglePlr = new JCheckBox();
  JCheckBox chkCoop = new JCheckBox();
  JCheckBox chkEMFH = new JCheckBox();
  JCheckBox chkBall = new JCheckBox();
  JCheckBox chkKOTH = new JCheckBox();
  JCheckBox chkCTF = new JCheckBox();
  JCheckBox chkDefense = new JCheckBox();
  JCheckBox chkRugby = new JCheckBox();
    JComboBox levelSelector = new JComboBox();
  JLabel jLabel1 = new JLabel();
  JButton btnLoad = new JButton();
    JTextField txtPath = new JTextField();
    JMenu mnuEdit = new JMenu();
    JMenuItem mnuPrefs = new JMenuItem();
    JMenuItem mnuChngMapName = new JMenuItem();
    JMenuItem jMenuItem1 = new JMenuItem();
    JMenuItem jMenuItem2 = new JMenuItem();
    JMenuItem jMenuItem3 = new JMenuItem();
    JCheckBox chkExploration = new JCheckBox();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JCheckBox chkRetrieval = new JCheckBox();
    JCheckBox chkRepair = new JCheckBox();
    JCheckBox chkRescue = new JCheckBox();
    JCheckBox chkExtermination = new JCheckBox();
    JLabel jLabel4 = new JLabel();
    JCheckBox chkLowGrav = new JCheckBox();
    JCheckBox chkRebellion = new JCheckBox();
    JCheckBox jCheckBox3 = new JCheckBox();
    JCheckBox chkVacuum = new JCheckBox();
    JCheckBox chkMagnetic = new JCheckBox();
    JLabel jLabel5 = new JLabel();
    JCheckBox chkDayLhowon = new JCheckBox();
    JCheckBox chkNightLhowon = new JCheckBox();
    JCheckBox chkMoon = new JCheckBox();
    JCheckBox chkSpace = new JCheckBox();
    JMenuItem jMenuItem4 = new JMenuItem();
    JMenuItem jMenuItem5 = new JMenuItem();
    JMenuItem jMenuItem6 = new JMenuItem();
    JMenuItem jMenuItem7 = new JMenuItem();
    JProgressBar progBar = new JProgressBar();
    JMenuItem jMenuItem8 = new JMenuItem();
    JMenuItem jMenuItem9 = new JMenuItem();
    JMenuItem jMenuItem10 = new JMenuItem();
    JMenuItem jMenuItem11 = new JMenuItem();
    JMenu jMenu1 = new JMenu();
    JMenuItem jMenuItem12 = new JMenuItem();
    JMenu jMenu2 = new JMenu();
    JMenuItem jMenuItem13 = new JMenuItem();
    JMenuItem jMenuItem14 = new JMenuItem();
    JMenuItem mnuAddShapesPatch = new JMenuItem();

    public void removeChildFrame(JFrame window){
      for(int i = 0; i < childFrames.size(); i++){
          if(childFrames.get(i).equals(window)){
              childFrames.remove(i);
          }
      }
  }

  public void addChildFrame(JFrame window){
      childFrames.add(window);
  }

  public void jMenuItem1_actionPerformed(ActionEvent e) { // Open file menu
    String openFile = "";
    final JFileChooser fc = new JFileChooser();

    String path = Preferences.MAPS_PATH;
    try{
        if (!path.equals(""))
            fc.setCurrentDirectory(new File(path));
    }catch(Exception ex){
        System.out.println(e);
        fc.setCurrentDirectory(new File("user.dir"));
    }
    int retVal = fc.showOpenDialog(FlagsFrame.this);
    if(retVal == JFileChooser.APPROVE_OPTION)
        openFile = fc.getSelectedFile().getPath();
    else if(retVal == JFileChooser.CANCEL_OPTION) return;

    this.setTitle("JUICE - " + fc.getSelectedFile().getName());
    closeAllChildFrames();
    turnProgOn();
    ProgressLoadThread p = new ProgressLoadThread(model, openFile);
    p.start();
  }

  public void initLoad(){
      fillLevelSelector();
      loadGametypeCheckboxes();
      loadMissionCheckboxes();
      loadEnvCheckboxes();
      loadLandscape();
  }

  private void closeAllChildFrames(){
      for(int i = 0; i < childFrames.size(); i++){
          ((JFrame)childFrames.get(i)).dispose();
      }
      childFrames = new ArrayList();
  }

  public void jMenuItemSave_actionPerformed(ActionEvent e) { // Save menu
      turnProgOn();
      ProgressWriteThread p = new ProgressWriteThread(model);
      p.start();
  }

  public void jMenuItem6_actionPerformed(ActionEvent e) { // Save As menu
      String saveFile = "";
      JFileChooser fc = new JFileChooser();

      String path = Preferences.MAPS_PATH;
      try {
          if (!path.equals(""))
              fc.setCurrentDirectory(new File(path));
      } catch (Exception ex) {
          System.out.println(e);
          fc.setCurrentDirectory(new File("user.dir"));
      }
      int retVal = fc.showSaveDialog(FlagsFrame.this);
      if(retVal == JFileChooser.APPROVE_OPTION)
          saveFile = fc.getSelectedFile().getPath();
      else if(retVal == JFileChooser.CANCEL_OPTION) return;

      this.setTitle("JUICE - " + fc.getSelectedFile().getName());
      turnProgOn();
      ProgressWriteNewThread p = new ProgressWriteNewThread(model, saveFile);
      p.start();
  }

  public void jMenuItem3_actionPerformed(ActionEvent e) { // Quit menu
      System.exit(0);
  }

  public void jMenuItem2_actionPerformed(ActionEvent e) { // Preferences Menu
      PrefsFrame pf = new PrefsFrame(model);
      childFrames.add(pf);
  }

  public void mnuChngMapName_actionPerformed(ActionEvent e) { // Change Map Name Menu

      MapNameFrame mn = new MapNameFrame(model,
                                         levelSelector.getSelectedIndex());
      childFrames.add(mn);
  }


  public void jMenuItem4_actionPerformed(ActionEvent e) { // Item parameters menu
      PlacFrame p = new PlacFrame(model, levelSelector.getSelectedIndex(),
                                  PlacFrame.ITEMS);
      childFrames.add(p);
  }

  public void jMenuItem5_actionPerformed(ActionEvent e) { // Monster plac menu
      PlacFrame p = new PlacFrame(model, levelSelector.getSelectedIndex(),
                                  PlacFrame.MONSTERS);
      childFrames.add(p);
  }

  public void jMenuItem8_actionPerformed(ActionEvent e) { // Polygon menu
      PolyFrame poly = new PolyFrame(model, levelSelector.getSelectedIndex());
      childFrames.add(poly);
  }


  public void jMenuItem9_actionPerformed(ActionEvent e) { // Objects menu
      ObjsFrame objs = new ObjsFrame(model, levelSelector.getSelectedIndex());
      childFrames.add(objs);
  }


  public void jMenuItem11_actionPerformed(ActionEvent e) { // Lines menu
      LinsFrame lins = new LinsFrame(model, levelSelector.getSelectedIndex());
      childFrames.add(lins);
  }

  public void jMenuItem14_actionPerformed(ActionEvent e) { // Sides menu
      SidsFrame sids = new SidsFrame(model, levelSelector.getSelectedIndex());
      childFrames.add(sids);
  }

  public void mnuAddShapesPatch_actionPerformed(ActionEvent e) { // Add Shapes Patch menu
      String openFile = "";
      boolean worked = false;
      while(worked == false){
          worked = true;
          JFileChooser fc = new JFileChooser();
          fc.setCurrentDirectory(new File("./"));

          int retVal = fc.showOpenDialog(FlagsFrame.this);
          if (retVal == JFileChooser.APPROVE_OPTION)
              openFile = fc.getSelectedFile().getPath();
          else if (retVal == JFileChooser.CANCEL_OPTION)return;
          try {
              model.addShapesPatch(levelSelector.getSelectedIndex(), openFile);
          } catch (NotShPaException notShape) {
              worked = false;
          } catch (TooLongException tooLong) {
              worked = false;
          }
      }
  }

  public void jMenuItem7_actionPerformed(ActionEvent e) { // Level Comment menu
      CommentFrame c = new CommentFrame(model, levelSelector.getSelectedIndex());
      childFrames.add(c);
  }

  public void jMenuItem10_actionPerformed(ActionEvent e) { // Visual mode window
      VisualMode v = new VisualMode(model);
      childFrames.add(v);
  }

  public void jMenuItem12_actionPerformed(ActionEvent e) { // Convert texture menu
      ConvertFrame c = new ConvertFrame(model, getLevelIndex());
      childFrames.add(c);
  }

  public void jMenuItem13_actionPerformed(ActionEvent e) { // About menu
      AboutFrame ab = new AboutFrame();
      childFrames.add(ab);
  }


  private void loadGametypeCheckboxes(){
    boolean[] flags = model.loadGametypeCheckboxInfo(getLevelIndex());
    if(flags == null) return;
    if(flags[0]) chkSinglePlr.setSelected(true);
    else chkSinglePlr.setSelected(false);
    if(flags[1]) chkCoop.setSelected(true);
    else chkCoop.setSelected(false);
    if(flags[2]) chkEMFH.setSelected(true);
    else chkEMFH.setSelected(false);
    if(flags[3]) chkBall.setSelected(true);
    else chkBall.setSelected(false);
    if(flags[4]) chkKOTH.setSelected(true);
    else chkKOTH.setSelected(false);
    if(flags[2] && flags[3]) chkCTF.setSelected(true);
    else chkCTF.setSelected(false);
    if(flags[5]) chkDefense.setSelected(true);
    else chkDefense.setSelected(false);
    if(flags[6]) chkRugby.setSelected(true);
    else chkRugby.setSelected(false);
  }

  private void loadMissionCheckboxes(){
      boolean[] flags = model.loadMissionCheckboxInfo(getLevelIndex());
      if(flags == null) return;
      if(flags[0]) chkExtermination.setSelected(true);
      else chkExtermination.setSelected(false);
      if(flags[1]) chkExploration.setSelected(true);
      else chkExploration.setSelected(false);
      if(flags[2]) chkRetrieval.setSelected(true);
      else chkRetrieval.setSelected(false);
      if(flags[3]) chkRepair.setSelected(true);
      else chkRepair.setSelected(false);
      if(flags[4]) chkRescue.setSelected(true);
      else chkRescue.setSelected(false);
  }

  private void loadEnvCheckboxes(){
      boolean[] flags = model.loadEnvCheckboxInfo(getLevelIndex());
      if(flags == null) return;
      if(flags[0]) chkVacuum.setSelected(true);
      else chkVacuum.setSelected(false);
      if(flags[1]) chkMagnetic.setSelected(true);
      else chkMagnetic.setSelected(false);
      if(flags[2]) chkRebellion.setSelected(true);
      else chkRebellion.setSelected(false);
      if(flags[3]) chkLowGrav.setSelected(true);
      else chkLowGrav.setSelected(false);
  }

  private void loadLandscape(){
          /* 0 == lh'owon day
           * 1 == lh'owon night
           * 2 == moon
           * 3 == space */
      if(model.getLandscape(getLevelIndex()) == -1) return;
      if(model.getLandscape(getLevelIndex()) == 0){
          chkDayLhowon.setSelected(true);
          chkNightLhowon.setSelected(false);
          chkMoon.setSelected(false);
          chkSpace.setSelected(false);
      }
      else if(model.getLandscape(getLevelIndex()) == 1){
          chkDayLhowon.setSelected(false);
          chkNightLhowon.setSelected(true);
          chkMoon.setSelected(false);
          chkSpace.setSelected(false);
      }
      else if(model.getLandscape(getLevelIndex()) == 2){
          chkDayLhowon.setSelected(false);
          chkNightLhowon.setSelected(false);
          chkMoon.setSelected(true);
          chkSpace.setSelected(false);
      }
      else{
          chkDayLhowon.setSelected(false);
          chkNightLhowon.setSelected(false);
          chkMoon.setSelected(false);
          chkSpace.setSelected(true);
      }
    }

  public void fillLevelSelector(){
    levelSelector.removeAllItems();
    for(int i = 0; i < model.getNumLevels(); i++){
      levelSelector.addItem(model.getLevelSelectName(i));
    }
  }

  private boolean[] getFlagArray(){
      boolean[] flagValues = new boolean[7];
      if (chkSinglePlr.isSelected())
          flagValues[0] = true;
      else flagValues[0] = false;
      if (chkCoop.isSelected())
          flagValues[1] = true;
      else flagValues[1] = false;
      if (chkEMFH.isSelected())
          flagValues[2] = true;
      else flagValues[2] = false;
      if (chkBall.isSelected())
          flagValues[3] = true;
      else flagValues[3] = false;
      if (chkKOTH.isSelected())
          flagValues[4] = true;
      else flagValues[4] = false;
      if (chkDefense.isSelected())
          flagValues[5] = true;
      else flagValues[5] = false;
      if (chkRugby.isSelected())
          flagValues[6] = true;
      else flagValues[6] = false;
      return flagValues;
  }

  private boolean[] getMissionArray(){
      boolean[] missionValues = new boolean[5];
      if(chkExtermination.isSelected())
          missionValues[0] = true;
      else missionValues[0] = false;
      if(chkExploration.isSelected())
          missionValues[1] = true;
      else missionValues[1] = false;
      if(chkRetrieval.isSelected())
          missionValues[2] = true;
      else missionValues[2] = false;
      if(chkRepair.isSelected())
          missionValues[3] = true;
      else missionValues[3] = false;
      if(chkRescue.isSelected())
          missionValues[4] = true;
      else missionValues[4] = false;
      return missionValues;
  }

  private boolean[] getEnvironmentArray(){
      boolean[] envValues = new boolean[4];
      if(chkVacuum.isSelected())
          envValues[0] = true;
      else envValues[0] = false;
      if(chkMagnetic.isSelected())
          envValues[1] = true;
      else envValues[1] = false;
      if(chkRebellion.isSelected())
          envValues[2] = true;
      else envValues[2] = false;
      if(chkLowGrav.isSelected())
          envValues[3] = true;
      else envValues[3] = false;
      return envValues;
  }

  public int getLevelIndex(){
    if(levelSelector.getSelectedIndex() < 0) return 0;
    else return levelSelector.getSelectedIndex();
  }

  public void levelSelector_actionPerformed(ActionEvent e) {
    loadGametypeCheckboxes();
    loadMissionCheckboxes();
    loadEnvCheckboxes();
    loadLandscape();
  }

  public void btnLoad_actionPerformed(ActionEvent e) {
    model.openMapFile(txtPath.getText() );
    fillLevelSelector();
    loadGametypeCheckboxes();
    loadMissionCheckboxes();
    loadEnvCheckboxes();
    loadLandscape();
  }

    public void chkEMFH_actionPerformed(ActionEvent e) {
        if(chkEMFH.isSelected() && chkBall.isSelected())
            chkCTF.setSelected(true);
        else chkCTF.setSelected(false);
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkBall_actionPerformed(ActionEvent e) {
        if(chkEMFH.isSelected() && chkBall.isSelected())
            chkCTF.setSelected(true);
        else chkCTF.setSelected(false);
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkSinglePlr_actionPerformed(ActionEvent e) {
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkCoop_actionPerformed(ActionEvent e) {
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkKOTH_actionPerformed(ActionEvent e) {
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkDefense_actionPerformed(ActionEvent e) {
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkRugby_actionPerformed(ActionEvent e) {
        model.saveGametypeCheckboxInfo(getLevelIndex(), getFlagArray());
    }

    public void chkExtermination_actionPerformed(ActionEvent e) {
        model.saveMissionCheckboxInfo(getLevelIndex(), getMissionArray());
    }

    public void chkExploration_actionPerformed(ActionEvent e) {
        model.saveMissionCheckboxInfo(getLevelIndex(), getMissionArray());
    }

    public void chkRetrieval_actionPerformed(ActionEvent e) {
        model.saveMissionCheckboxInfo(getLevelIndex(), getMissionArray());
    }

    public void chkRepair_actionPerformed(ActionEvent e) {
        model.saveMissionCheckboxInfo(getLevelIndex(), getMissionArray());
    }

    public void chkRescue_actionPerformed(ActionEvent e) {
        model.saveMissionCheckboxInfo(getLevelIndex(), getMissionArray());
    }

    public void chkVacuum_actionPerformed(ActionEvent e) {
        model.saveEnvironmentCheckboxInfo(getLevelIndex(), getEnvironmentArray());
    }

    public void chkRebellion_actionPerformed(ActionEvent e) {
        model.saveEnvironmentCheckboxInfo(getLevelIndex(), getEnvironmentArray());
    }

    public void chkLowGrav_actionPerformed(ActionEvent e) {
        model.saveEnvironmentCheckboxInfo(getLevelIndex(), getEnvironmentArray());
    }

    public void chkMagnetic_actionPerformed(ActionEvent e) {
        model.saveEnvironmentCheckboxInfo(getLevelIndex(), getEnvironmentArray());
    }

    public void chkDayLhowon_actionPerformed(ActionEvent e) {
        chkDayLhowon.setSelected(true);
        chkNightLhowon.setSelected(false);
        chkMoon.setSelected(false);
        chkSpace.setSelected(false);

        //model.setLandscape(getLevelIndex(), (short)0);
    }

    public void chkNightLhowon_actionPerformed(ActionEvent e) {
        chkDayLhowon.setSelected(false);
        chkNightLhowon.setSelected(true);
        chkMoon.setSelected(false);
        chkSpace.setSelected(false);

        model.setLandscape(getLevelIndex(), (short)1);
    }

    public void chkMoon_actionPerformed(ActionEvent e) {
        chkDayLhowon.setSelected(false);
        chkNightLhowon.setSelected(false);
        chkMoon.setSelected(true);
        chkSpace.setSelected(false);

        model.setLandscape(getLevelIndex(), (short)2);
    }

    public void chkSpace_actionPerformed(ActionEvent e) {
        chkDayLhowon.setSelected(false);
        chkNightLhowon.setSelected(false);
        chkMoon.setSelected(false);
        chkSpace.setSelected(true);

        model.setLandscape(getLevelIndex(), (short)3);
    }

    public void turnProgOn(){
        progBar.setVisible(true);
        this.setEnabled(false);
        for(int i = 0; i < childFrames.size(); i++){
            ((JFrame)childFrames.get(i)).setEnabled(false);
        }
    }

    public void turnProgOff(){
        progBar.setVisible(false);
        this.setEnabled(true);
        for(int i = 0; i < childFrames.size(); i++){
            ((JFrame)childFrames.get(i)).setEnabled(true);
        }
    }
}

class ProgressLoadThread extends Thread{
    Model model;
    String openFile;

    public ProgressLoadThread(Model model, String openFile){
        this.model = model;
        this.openFile = openFile;
    }

    public void run(){
        try{
            model.openMapFile(openFile);
            model.initLoad();
            model.turnProgOff();
        } catch(Exception e){
            System.out.println("Problem opening map file");
            model.turnProgOff();
        }
    }
}

class ProgressWriteThread extends Thread{
    Model model;

    public ProgressWriteThread(Model model){
        this.model = model;
    }

    public void run(){
        try{
            model.writeData();
            model.turnProgOff();
        } catch(Exception e){
            System.out.println(e);
            //System.out.println("Problem saving to map file");
            model.turnProgOff();
        }
    }
}

class ProgressWriteNewThread extends Thread{
    Model model;
    String saveFile;

    public ProgressWriteNewThread(Model model, String saveFile){
        this.model = model;
        this.saveFile = saveFile;
    }

    public void run(){
        try{
            model.writeNew(saveFile);
            model.turnProgOff();
        } catch(Exception e){
            System.out.println(e);
            //System.out.println("Problem saving to new map file");
            model.turnProgOff();
        }
    }
}

class FlagsFrame_chkExploration_actionAdapter implements ActionListener {
    private FlagsFrame adaptee;
    FlagsFrame_chkExploration_actionAdapter(FlagsFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.chkExploration_actionPerformed(e);
    }
}
