/*
Copyright 2007 Darren Watts

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import src.backend.StaticFunctions;

public class MapNameFrame extends JFrame {
    private Model model;
    private int lvlIndex;

    public MapNameFrame(Model m, int levelIndex) {
        try {
            model = m;
            lvlIndex = levelIndex;
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(null);
        this.setJMenuBar(null);
        jLabel1.setText("Level Over Head Name:");
        jLabel1.setBounds(new Rectangle(13, 76, 295, 23));
        txtOverHeadName.setText("");
        txtOverHeadName.setBounds(new Rectangle(13, 108, 315, 23));
        txtSelectionName.setText("");
        txtSelectionName.setBounds(new Rectangle(13, 44, 315, 23));
        btnOK.setBounds(new Rectangle(180, 152, 80, 31));
        btnOK.setText("OK");
        btnOK.addActionListener(new MapNameFrame_btnOK_actionAdapter(this));
        btnCancel.setBounds(new Rectangle(88, 152, 80, 31));
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new MapNameFrame_btnCancel_actionAdapter(this));
        this.getContentPane().add(jLabel3);
        this.getContentPane().add(txtSelectionName);
        this.getContentPane().add(jLabel1);
        this.getContentPane().add(txtOverHeadName);
        this.getContentPane().add(btnCancel);
        this.getContentPane().add(btnOK);
        jLabel3.setText("Level Selection Name:");
        jLabel3.setBounds(new Rectangle(13, 12, 295, 23));

        if(model.getLevelSelectName(lvlIndex) == null) return;
        txtSelectionName.setText(model.getLevelSelectName(lvlIndex));
        txtOverHeadName.setText(model.getLevelOverHeadName(lvlIndex));

        if(!model.getIsMerged()){
            jLabel3.setText("Level Selection Name: (merged maps only)");
            txtSelectionName.setEnabled(false);
        }

        setSize(350, 220);
        setTitle("Change Map Name");
        StaticFunctions.centerFrame(this);
        setResizable(false);
        setVisible(true);

    }

    JLabel jLabel1 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JTextField txtSelectionName = new JTextField();
    JTextField txtOverHeadName = new JTextField();
    JButton btnOK = new JButton();
    JButton btnCancel = new JButton();

    public void btnCancel_actionPerformed(ActionEvent e) {
        model.removeChildFrame(this);
        this.dispose();
    }

    public void btnOK_actionPerformed(ActionEvent e) {
        model.setLevelSelectName(txtSelectionName.getText(), lvlIndex);
        model.setLevelSelectorNames();
        model.setLevelOverHeadName(txtOverHeadName.getText(), lvlIndex);

        if(!model.getIsMerged()){
            model.setLevelSelectName(txtOverHeadName.getText(), lvlIndex);
            model.setLevelSelectorNames();
        }
        model.removeChildFrame(this);
        this.dispose();
    }
}


class MapNameFrame_btnOK_actionAdapter implements ActionListener {
    private MapNameFrame adaptee;
    MapNameFrame_btnOK_actionAdapter(MapNameFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnOK_actionPerformed(e);
    }
}


class MapNameFrame_btnCancel_actionAdapter implements ActionListener {
    private MapNameFrame adaptee;
    MapNameFrame_btnCancel_actionAdapter(MapNameFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnCancel_actionPerformed(e);
    }
}
