/*
Copyright 2007 Darren Watts

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class MessageBox extends JDialog {

    private String message;

    public MessageBox(String message) {
        try {
            this.message = message;
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(null);
        btnOK.setBounds(new Rectangle(156, 126, 70, 39));
        btnOK.setText("OK");
        btnOK.addActionListener(new MessageBox_btnOK_actionAdapter(this));
        this.getContentPane().setBackground(SystemColor.control);
        this.setForeground(Color.lightGray);
        this.setModal(true);
        this.setResizable(false);
        lblRoof.setText("");
        lblRoof.setBounds(new Rectangle(156, 2, 68, 66));
        java.net.URL u = VisualMode.class.getResource("data/RN.png");
        ImageIcon image = new ImageIcon(u);
        if(image != null)
            lblRoof.setIcon(image);
        lblMessage.setText(message);
        lblMessage.setBounds(new Rectangle(5, 79, 370, 35));
        this.getContentPane().add(btnOK);
        this.getContentPane().add(lblRoof);
        this.getContentPane().add(lblMessage);
        this.setTitle("Roof Notification!");

        centerFrame();

        this.setSize(400, 195);
        this.setVisible(true);
    }

    JButton btnOK = new JButton();
    JLabel lblRoof = new JLabel();
    JLabel lblMessage = new JLabel();
    public void btnOK_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    public void centerFrame(){
        Toolkit tk = Toolkit.getDefaultToolkit();
        Dimension screen = tk.getScreenSize();

        int lx = (int) (screen.getWidth() * 3 / 8);
        int ly = (int) (screen.getHeight() * 3 / 8);
        this.setLocation(lx, ly);
    }

}


class MessageBox_btnOK_actionAdapter implements ActionListener {
    private MessageBox adaptee;
    MessageBox_btnOK_actionAdapter(MessageBox adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnOK_actionPerformed(e);
    }
}
