/*
  Copyright 2007 Darren Watts

  This file is part of JUICE.

  JUICE is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  JUICE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with JUICE; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

package src.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import src.backend.*;
import java.awt.event.KeyEvent;

public class ObjsQuestionFrame extends JFrame {
    private Model model;
    private int levelIndex;
    JLabel jLabel1 = new JLabel();
    JTextField txtLineNumber = new JTextField();
    JButton btnOK = new JButton();
    ObjsEntry[] data;

    public ObjsQuestionFrame(Model model, int levelIndex, ObjsEntry[] data) {
        this.model = model;
        this.levelIndex = levelIndex;
        this.data = data;
        try {
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(null);
        jLabel1.setText("Line number of object:");
        jLabel1.setBounds(new Rectangle(21, 13, 337, 23));
        btnOK.addActionListener(new ObjsQuestionFrame_btnOK_actionAdapter(this));
        this.getContentPane().add(jLabel1);
        btnOK.setBounds(new Rectangle(45, 68, 78, 26));
        btnOK.setText("OK");
        this.getContentPane().add(txtLineNumber);
        this.getContentPane().add(btnOK);
        txtLineNumber.setText("");
        txtLineNumber.setBounds(new Rectangle(21, 40, 127, 20));

        this.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ENTER){
                    closeWindow();
                }
            }
        });
        txtLineNumber.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if(e.getKeyCode() == KeyEvent.VK_ENTER){
                    closeWindow();
                }
            }
        });
    }

    public void closeWindow(){
        ObjsFlagsFrame objFF = new ObjsFlagsFrame(model, levelIndex,
                                                  data[Integer.parseInt(txtLineNumber.getText())]);
        this.dispose();
    }

    public void btnOK_actionPerformed(ActionEvent e) {
        closeWindow();
    }
}


class ObjsQuestionFrame_btnOK_actionAdapter implements ActionListener {
    private ObjsQuestionFrame adaptee;
    ObjsQuestionFrame_btnOK_actionAdapter(ObjsQuestionFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnOK_actionPerformed(e);
    }
}
