/*Copyright 2007 Darren Watts

This file is part of JUICE.

JUICE is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

JUICE is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with JUICE; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import javax.swing.JFrame;
import javax.swing.JLabel;
import java.awt.*;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import src.backend.*;

public class PrefsFrame extends JFrame {
    private Model model;
    public PrefsFrame(Model model) {
        this.model = model;
        try {
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(null);
        jLabel1.setText("Auto Fill values:");
        jLabel1.setBounds(new Rectangle(23, 114, 351, 25));
        btnOK.setBounds(new Rectangle(206, 223, 80, 31));
        btnOK.setText("OK");
        btnOK.addActionListener(new PrefsFrame_btnOK_actionAdapter(this));
        btnCancel.setBounds(new Rectangle(112, 223, 80, 31));
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new PrefsFrame_btnCancel_actionAdapter(this));
        jLabel2.setText("Default Path to Scripts Directory:");
        jLabel2.setBounds(new Rectangle(23, 65, 351, 25));
        jLabel3.setText("* Initial");
        jLabel3.setBounds(new Rectangle(139, 167, 65, 18));
        txtMin.setText("");
        txtMin.setBounds(new Rectangle(89, 144, 44, 17));
        jLabel4.setText("Maximum =");
        jLabel4.setBounds(new Rectangle(23, 167, 65, 18));
        jLabel5.setText("Minimum =");
        jLabel5.setBounds(new Rectangle(24, 143, 65, 18));
        jLabel6.setText("* Initial");
        jLabel6.setBounds(new Rectangle(139, 143, 65, 18));
        txtMax.setBounds(new Rectangle(89, 168, 44, 17));
        jLabel7.setText("Appearance % =");
        jLabel7.setBounds(new Rectangle(23, 193, 100, 15));
        txtAppearPercent.setBounds(new Rectangle(127, 191, 44, 17));
        jLabel8.setText("Default Path to Map Directory:");
        jLabel8.setBounds(new Rectangle(23, 16, 351, 25));
        txtPathScripts.setBounds(new Rectangle(23, 91, 354, 22));
        this.getContentPane().add(jLabel1);
        this.getContentPane().add(jLabel5);
        this.getContentPane().add(jLabel3);
        this.getContentPane().add(txtMax);
        this.getContentPane().add(jLabel6);
        this.getContentPane().add(txtMin);
        this.getContentPane().add(jLabel4);
        this.getContentPane().add(jLabel7);
        this.getContentPane().add(txtAppearPercent);
        this.getContentPane().add(btnCancel);
        this.getContentPane().add(btnOK);
        this.getContentPane().add(jLabel2);
        this.getContentPane().add(jLabel8);
        this.getContentPane().add(txtPrefsPath);
        this.getContentPane().add(txtPathScripts);
        txtPrefsPath.setText("");
        txtPrefsPath.setBounds(new Rectangle(23, 42, 354, 22));

        fillText();

        setSize(410, 300);
        setTitle("JUICE Preferences");
        StaticFunctions.centerFrame(this);
        setResizable(false);
        setVisible(true);

    }

    private void fillText(){
        txtPrefsPath.setText(Preferences.MAPS_PATH);
        txtPathScripts.setText(Preferences.SCRIPTS_PATH);
        txtMin.setText(String.valueOf(Preferences.MIN_MULT));
        txtMax.setText(String.valueOf(Preferences.MAX_MULT));
        txtAppearPercent.setText(String.valueOf(Preferences.APPEAR_PERCENT));
    }

    JLabel jLabel1 = new JLabel();
    JTextField txtPrefsPath = new JTextField();
    JButton btnOK = new JButton();
    JButton btnCancel = new JButton();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JTextField txtMin = new JTextField();
    JLabel jLabel4 = new JLabel();
    JLabel jLabel5 = new JLabel();
    JTextField txtMax = new JTextField();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JTextField txtAppearPercent = new JTextField();
    JLabel jLabel8 = new JLabel();
    JTextField txtPathScripts = new JTextField();

    public void btnOK_actionPerformed(ActionEvent e) {
        try{
            Preferences.setPrefs(txtPrefsPath.getText(),
                                 txtPathScripts.getText(),
                                 Double.parseDouble(txtMin.getText()),
                                 Double.parseDouble(txtMax.getText()),
                                 Integer.parseInt(txtAppearPercent.getText()));
        } catch(Exception ex){
            MessageBox msg = new MessageBox("Enter valid numbers into\nevery field");
            return;
        }
        model.removeChildFrame(this);
        this.dispose();
    }

    public void btnCancel_actionPerformed(ActionEvent e) {
        model.removeChildFrame(this);
        this.dispose();
    }
}


class PrefsFrame_btnCancel_actionAdapter implements ActionListener {
    private PrefsFrame adaptee;
    PrefsFrame_btnCancel_actionAdapter(PrefsFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnCancel_actionPerformed(e);
    }
}


class PrefsFrame_btnOK_actionAdapter implements ActionListener {
    private PrefsFrame adaptee;
    PrefsFrame_btnOK_actionAdapter(PrefsFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnOK_actionPerformed(e);
    }
}
