/*
  Copyright 2007 Darren Watts

  This file is part of JUICE.

  JUICE is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  JUICE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with JUICE; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import java.awt.*;
import javax.swing.*;
import src.backend.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SidsPropertiesFrame extends JFrame {
    private Model model;
    private int levelIndex;
    private SidsEntry entry;

    public SidsPropertiesFrame(Model model, int levelIndex, SidsEntry entry) {
        try {
            this.model = model;
            this.levelIndex = levelIndex;
            this.entry = entry;
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(null);
        jLabel1.setText("Permutation:");
        jLabel1.setBounds(new Rectangle(23, 8, 95, 21));
        jLabel2.setToolTipText("");
        jLabel2.setText("Bitmap:");
        jLabel2.setBounds(new Rectangle(215, 54, 95, 17));
        jLabel3.setToolTipText("");
        jLabel3.setText("Transfer Mode:");
        jLabel3.setBounds(new Rectangle(317, 54, 95, 17));
        jLabel4.setToolTipText("");
        jLabel4.setText("Light:");
        jLabel4.setBounds(new Rectangle(420, 54, 95, 17));
        jLabel5.setToolTipText("");
        jLabel5.setText("Primary:");
        jLabel5.setBounds(new Rectangle(11, 100, 95, 17));
        jLabel6.setToolTipText("");
        jLabel6.setText("Secondary:");
        jLabel6.setBounds(new Rectangle(11, 170, 95, 17));
        jLabel7.setToolTipText("");
        jLabel7.setText("Transparent:");
        jLabel7.setBounds(new Rectangle(11, 246, 95, 17));
        jLabel8.setToolTipText("");
        jLabel8.setText("Collection:");
        jLabel8.setBounds(new Rectangle(112, 54, 95, 17));
        cmbSecCol.setBounds(new Rectangle(112, 169, 95, 18));
        txtSecBit.setText("");
        txtSecBit.setBounds(new Rectangle(215, 169, 95, 18));
        txtTransBit.setText("");
        txtTransBit.setBounds(new Rectangle(215, 245, 95, 18));
        txtPriTrans.setText("");
        txtPriTrans.setBounds(new Rectangle(317, 99, 95, 18));
        txtSecTrans.setText("");
        txtSecTrans.setBounds(new Rectangle(317, 169, 95, 18));
        txtTransTrans.setText("");
        txtTransTrans.setBounds(new Rectangle(317, 245, 95, 18));
        txtPriLight.setText("");
        txtPriLight.setBounds(new Rectangle(420, 99, 95, 18));
        txtSecLight.setText("");
        txtSecLight.setBounds(new Rectangle(420, 169, 95, 18));
        txtTransLight.setText("");
        txtTransLight.setBounds(new Rectangle(420, 245, 95, 18));
        txtPriBit.setText("");
        txtPriBit.setBounds(new Rectangle(215, 99, 95, 18));
        cmbTransCol.setBounds(new Rectangle(112, 245, 95, 18));
        cmbPriCol.setBounds(new Rectangle(112, 99, 95, 18));
        btnOK.setBounds(new Rectangle(272, 287, 82, 32));
        btnOK.setText("OK");
        btnOK.addActionListener(new SidsPropertiesFrame_btnOK_actionAdapter(this));
        btnCancel.setBounds(new Rectangle(172, 287, 82, 32));
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new
                                    SidsPropertiesFrame_btnCancel_actionAdapter(this));
        jLabel9.setText("Panel type:");
        jLabel9.setBounds(new Rectangle(215, 8, 95, 21));
        cmbPanelType.setBounds(new Rectangle(317, 11, 198, 18));
        this.getContentPane().add(txtPerm);
        this.getContentPane().add(jLabel2);
        this.getContentPane().add(jLabel3);
        this.getContentPane().add(jLabel4);
        this.getContentPane().add(jLabel5);
        this.getContentPane().add(jLabel6);
        this.getContentPane().add(jLabel8);
        this.getContentPane().add(jLabel7);
        this.getContentPane().add(cmbSecCol);
        this.getContentPane().add(cmbTransCol);
        this.getContentPane().add(txtSecBit);
        this.getContentPane().add(txtTransBit);
        this.getContentPane().add(txtPriTrans);
        this.getContentPane().add(txtSecTrans);
        this.getContentPane().add(txtTransTrans);
        this.getContentPane().add(txtPriLight);
        this.getContentPane().add(txtSecLight);
        this.getContentPane().add(txtTransLight);
        this.getContentPane().add(cmbPriCol);
        this.getContentPane().add(txtPriBit);
        this.getContentPane().add(btnCancel);
        this.getContentPane().add(btnOK);
        this.getContentPane().add(jLabel1);
        this.getContentPane().add(jLabel9);
        this.getContentPane().add(cmbPanelType);
        txtPerm.setText("");
        txtPerm.setBounds(new Rectangle(112, 8, 95, 18));

        loadInfo();

        setSize(540, 360);
        setTitle("Side Property");
        StaticFunctions.centerFrame(this);
        setResizable(false);
        setVisible(true);
    }

    JLabel jLabel1 = new JLabel();
    JTextField txtPerm = new JTextField();
    JLabel jLabel2 = new JLabel();
    JLabel jLabel3 = new JLabel();
    JLabel jLabel4 = new JLabel();
    JLabel jLabel5 = new JLabel();
    JLabel jLabel6 = new JLabel();
    JLabel jLabel7 = new JLabel();
    JLabel jLabel8 = new JLabel();
    JComboBox cmbSecCol = new JComboBox();
    JComboBox cmbTransCol = new JComboBox();
    JComboBox cmbPriCol = new JComboBox();
    JTextField txtSecBit = new JTextField();
    JTextField txtTransBit = new JTextField();
    JTextField txtPriTrans = new JTextField();
    JTextField txtSecTrans = new JTextField();
    JTextField txtTransTrans = new JTextField();
    JTextField txtPriLight = new JTextField();
    JTextField txtSecLight = new JTextField();
    JTextField txtTransLight = new JTextField();
    JTextField txtPriBit = new JTextField();
    JButton btnOK = new JButton();
    JButton btnCancel = new JButton();
    JLabel jLabel9 = new JLabel();
    JComboBox cmbPanelType = new JComboBox();

    private void loadInfo(){
        int temp = 0;
        txtPerm.setText(String.valueOf(entry.getPanelPermutation()));

        // Primary Collection Combo box
        cmbPriCol.addItem("Water");
        cmbPriCol.addItem("Lava");
        cmbPriCol.addItem("Sewage");
        cmbPriCol.addItem("Jjaro");
        cmbPriCol.addItem("Pfhor");

        // Secondary Collection Combo box
        cmbSecCol.addItem("Water");
        cmbSecCol.addItem("Lava");
        cmbSecCol.addItem("Sewage");
        cmbSecCol.addItem("Jjaro");
        cmbSecCol.addItem("Pfhor");

        // Transparent Collection Combo box
        cmbTransCol.addItem("Water");
        cmbTransCol.addItem("Lava");
        cmbTransCol.addItem("Sewage");
        cmbTransCol.addItem("Jjaro");
        cmbTransCol.addItem("Pfhor");

        // Panel type combo box
        for(int i = 0; i < StaticFunctions.PANEL_TYPES.length; i++){
            cmbPanelType.addItem(StaticFunctions.PANEL_TYPES[i]);
        }

        try{
            cmbPanelType.setSelectedIndex(entry.getPanelType());
        } catch(Exception ex){
            cmbPanelType.setSelectedIndex(0);
        }

        cmbPriCol.setSelectedIndex(entry.getSideTextures()[0].getTexture().getColl() - 17);
        try{
            cmbSecCol.setSelectedIndex(entry.getSideTextures()[1].getTexture().
                                       getColl() - 17);
        } catch(Exception ex){
            cmbSecCol.setSelectedIndex(entry.getSideTextures()[0].getTexture().
                                       getColl() - 17);
        }
        try{
            cmbTransCol.setSelectedIndex(entry.getSideTextures()[2].getTexture().
                                         getColl() - 17);
        } catch(Exception ex){
            cmbTransCol.setSelectedIndex(entry.getSideTextures()[0].getTexture().
                                         getColl() - 17);
        }
        // Bitmaps
        temp = entry.getSideTextures()[0].getTexture().getBmp();
        if(temp == 255)
            txtPriBit.setText("None");
        else txtPriBit.setText(String.valueOf(temp));
        temp = entry.getSideTextures()[1].getTexture().getBmp();
        if(temp == 255)
            txtSecBit.setText("None");
        else txtSecBit.setText(String.valueOf(temp));
        temp = entry.getSideTextures()[2].getTexture().getBmp();
        if(temp == 255)
            txtTransBit.setText("None");
        else txtTransBit.setText(String.valueOf(temp));

        // Transfer modes
        txtPriTrans.setText(String.valueOf(entry.getPrimaryTransfer()));
        txtSecTrans.setText(String.valueOf(entry.getSecondaryTransfer()));
        txtTransTrans.setText(String.valueOf(entry.getTransparentTransfer()));

        // Lights
        txtPriLight.setText(String.valueOf(entry.getPrimaryLight()));
        txtSecLight.setText(String.valueOf(entry.getSecondaryLight()));
        txtTransLight.setText(String.valueOf(entry.getTransparentLight()));
    }

    public void btnCancel_actionPerformed(ActionEvent e) {
        model.removeChildFrame(this);
        dispose();
    }

    public void btnOK_actionPerformed(ActionEvent e) {
        int pri = 0, sec = 0, trans = 0;
        entry.setPanelPermutation((short)Integer.parseInt(txtPerm.getText()));

        try{
            entry.setPanelType((short)cmbPanelType.getSelectedIndex());
        } catch(Exception ex){
            entry.setPanelType((short)0);
        }

        // Collections
        entry.getSideTextures()[0].getTexture().setColl(cmbPriCol.getSelectedIndex() + 17);
        entry.getSideTextures()[1].getTexture().setColl(cmbSecCol.getSelectedIndex() + 17);
        entry.getSideTextures()[2].getTexture().setColl(cmbTransCol.getSelectedIndex() + 17);

        // Bitmaps
        pri = Integer.parseInt(txtPriBit.getText());
        try{
            sec = Integer.parseInt(txtSecBit.getText());
        } catch(NumberFormatException ex){
            sec = 255;
        }
        try{
            trans = Integer.parseInt(txtTransBit.getText());
        } catch(NumberFormatException ex){
            trans = 255;
        }

        if(pri < 0 || pri > 255) entry.getSideTextures()[0].getTexture().setBmp(255);
        else entry.getSideTextures()[0].getTexture().setBmp(pri);
        if(sec < 0 || sec > 255) entry.getSideTextures()[1].getTexture().setBmp(255);
        else entry.getSideTextures()[1].getTexture().setBmp(sec);
        if(trans < 0 || trans > 255) entry.getSideTextures()[2].getTexture().setBmp(255);
        else entry.getSideTextures()[2].getTexture().setBmp(trans);

        // Transfer modes
        entry.setPrimaryTransfer((short)Integer.parseInt(txtPriTrans.getText()));
        entry.setSecondaryTransfer((short)Integer.parseInt(txtSecTrans.getText()));
        entry.setTransparentTransfer((short)Integer.parseInt(txtTransTrans.getText()));

        // Lights
        entry.setPrimaryLight((short)Integer.parseInt(txtPriLight.getText()));
        entry.setSecondaryLight((short)Integer.parseInt(txtSecLight.getText()));
        entry.setTransparentLight((short)Integer.parseInt(txtTransLight.getText()));

        model.removeChildFrame(this);
        dispose();
    }
}


class SidsPropertiesFrame_btnOK_actionAdapter implements ActionListener {
    private SidsPropertiesFrame adaptee;
    SidsPropertiesFrame_btnOK_actionAdapter(SidsPropertiesFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnOK_actionPerformed(e);
    }
}


class SidsPropertiesFrame_btnCancel_actionAdapter implements ActionListener {
    private SidsPropertiesFrame adaptee;
    SidsPropertiesFrame_btnCancel_actionAdapter(SidsPropertiesFrame adaptee) {
        this.adaptee = adaptee;
    }

    public void actionPerformed(ActionEvent e) {
        adaptee.btnCancel_actionPerformed(e);
    }
}
