/*
  Copyright 2007 Darren Watts

  This file is part of JUICE.

  JUICE is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  JUICE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with JUICE; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

package src.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import src.backend.StaticFunctions;

public class VisualMode extends JFrame {
    private Model model;
    BorderLayout borderLayout1 = new BorderLayout();
    ImageIcon image;
    private java.net.URL u = VisualMode.class.getResource("data/VM.png");
    JLabel jLabel1 = new JLabel();
    public VisualMode(Model model) {
        this.model = model;
        try {
            jbInit();
        } catch (Exception exception) {
            exception.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        getContentPane().setLayout(borderLayout1);
        this.getContentPane().add(jLabel1, java.awt.BorderLayout.WEST); //getContentPane().add(picture);

        this.addWindowListener(new WindowListener(){
            public void windowDeactivated(WindowEvent e){}
            public void windowActivated(WindowEvent e) {}
            public void windowDeiconified(WindowEvent e) {}
            public void windowIconified(WindowEvent e) {}
            public void windowClosed(WindowEvent e) {}
            public void windowClosing(WindowEvent e) {
                closeTable();
            }
            public void windowOpened(WindowEvent e) {}
        });

        try {
            image = new ImageIcon(u);
            jLabel1.setIcon(image);
        } catch (Exception ex) {
            jLabel1.setText("Picture missing");
            return;
        }

        setSize(805, 720);
        setTitle("Visual Mode");
        StaticFunctions.centerFrame(this);
        setResizable(false);
        setVisible(true);

    }

    private void closeTable(){
        model.removeChildFrame(this);
    }
}
